import java.awt.Component;
import java.awt.Graphics;
import java.net.URL;
import javax.swing.Icon;
import javax.swing.ImageIcon;

public class ImageProxy implements Icon {

    private ImageIcon _icon;
    private URL       _url;
    private Thread    _t;
    private boolean   _retrieving = false;

    public ImageProxy(URL url) {
        _url = url;
    }

    public int getIconHeight() {
        if (_icon != null) {
            return _icon.getIconHeight();
        } else {
            return 600;
        }
    }

    public int getIconWidth() {
        if (_icon != null) {
            return _icon.getIconWidth();
        } else {
            return 800;
        }
    }

    public void paintIcon(final Component c, Graphics g, int x, int y) {
        if (_icon != null) {
            _icon.paintIcon(c, g, x, y);
        } else {
            g.drawString("Loading image, please wait...", x + 300, y + 190);
            if (!_retrieving) {
                _retrieving = true;
                _t = new Thread(
                         new Runnable() {
                             public void run() {
                                 try {
                                     _icon = new ImageIcon(_url, "Our Image");
                                     c.repaint();
                                 } catch (Exception ex) {
                                     ex.printStackTrace();
                                 }
                             }
                         });
                _t.start();
            }
        }
    }

}
