import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.net.URL;

import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

public class useImageProxy {

    ImageComponent _image;
    JFrame         _frame = new JFrame("Image Viewer");
    JMenuBar       _mbar;
    JMenu          _menu;
    Map            _images = new TreeMap();

    public static void main(String[] args) {
        useImageProxy client = new useImageProxy();
    }

    public useImageProxy() {

        // NOTE: if you compile this code on your own machine, you will
        //       need to change the lines below to match image files on
        //       your computer

        _images.put("Max Dinosaur" ,
                    "file:///Users/kena/Pictures/max_dinosaur.jpg");
        _images.put("2004 Election Results" ,
                    "file:///Users/kena/Pictures/2004countymap3.gif");
        _images.put("Earth At Night" ,
                    "file:///Users/kena/Pictures/earthAtNight.jpg");
        _images.put("Max Take Two" ,
                    "http://www.cs.colorado.edu/users/palen/family/mr-cute.jpg");

        URL url = null;

        try {
            url = new URL((String)_images.get("Max Dinosaur"));
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        _mbar   = new JMenuBar();
        _menu   = new JMenu("Images");

        _mbar.add(_menu);
        _frame.setJMenuBar(_mbar);

        Iterator itr = _images.keySet().iterator();
        while (itr.hasNext()) {
            String key = (String)itr.next();
            JMenuItem item = new JMenuItem(key);
            _menu.add(item);
            item.addActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent event) {
                        _image.setIcon(
                            new ImageProxy(
                                getURL(event.getActionCommand())));
                        _frame.repaint();
                    }
                });
        }

        Icon icon = new ImageProxy(url);
        _image    = new ImageComponent(icon);
        _frame.getContentPane().add(_image);
        _frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        _frame.setSize(800,600);
        _frame.setVisible(true);
        
    }

    private URL getURL(String name) {
        try {
            return new URL((String)_images.get(name));
        } catch (Exception ex) {
            ex.printStackTrace();
            return null;
        }
    }

}
